	.module RingBuffer.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\RingBuffer.c
	.dbfunc e Buffer_Initialize _Buffer_Initialize fV
	.dbstruct 0 37 .1
	.dbfield 0 Buffer A[32:32]c
	.dbfield 32 InPtr pc
	.dbfield 34 OutPtr pc
	.dbfield 36 Elements c
	.dbend
;      temp_SREG -> R10
;         Buffer -> R16,R17
	.even
_Buffer_Initialize::
	st -y,R10
	.dbline -1
	.dbline 4
; #include "RingBuffer.h"
; 
; void Buffer_Initialize(RingBuff_t* Buffer)
; {
	.dbline 8
; 	unsigned char temp_SREG;
;     
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R10,0x3f
	.dbline 9
;     CLI();//Disable global interrupts
	cli
	.dbline 11
;     
; 	Buffer->InPtr    = (RingBuff_Data_t*)&Buffer->Buffer;
	movw R30,R16
	std z+33,R17
	std z+32,R16
	.dbline 12
; 	Buffer->OutPtr   = (RingBuff_Data_t*)&Buffer->Buffer;
	std z+35,R17
	std z+34,R16
	.dbline 13
; 	Buffer->Elements = 0;
	clr R2
	std z+36,R2
	.dbline 16
;     
;     //Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R10
	.dbline -2
L2:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r temp_SREG 10 c
	.dbsym r Buffer 16 pS[.1]
	.dbend
	.dbfunc e Buffer_StoreElement _Buffer_StoreElement fV
;      temp_SREG -> R10
;           Data -> R18
;         Buffer -> R16,R17
	.even
_Buffer_StoreElement::
	xcall push_xgset300C
	.dbline -1
	.dbline 20
; }
; 
; void Buffer_StoreElement(RingBuff_t* Buffer, RingBuff_Data_t Data)
; {
	.dbline 24
; 	unsigned char temp_SREG;
;     
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R10,0x3f
	.dbline 25
;     CLI();//Disable global interrupts
	cli
	.dbline 28
; 	
; 	#if defined(BUFF_DROPOLD)
; 		if (Buffer->Elements == BUFF_LENGTH)
	movw R30,R16
	ldd R24,z+36
	cpi R24,32
	brne L4
X0:
	.dbline 29
; 		{
	.dbline 30
; 			Buffer->OutPtr++;
	movw R24,R30
	adiw R24,34
	movw R2,R24
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	std z+1,R25
	std z+0,R24
	.dbline 32
; 	
; 			if (Buffer->OutPtr == &Buffer->Buffer[BUFF_LENGTH])
	movw R24,R16
	adiw R24,32
	movw R30,R16
	ldd R2,z+34
	ldd R3,z+35
	cp R2,R24
	cpc R3,R25
	brne L5
X1:
	.dbline 33
; 			  Buffer->OutPtr = (RingBuff_Data_t*)&Buffer->Buffer;
	std z+35,R17
	std z+34,R16
	.dbline 34
; 		}
	xjmp L5
L4:
	.dbline 36
; 		else
; 		{
	.dbline 37
; 			Buffer->Elements++;
	movw R24,R16
	adiw R24,36
	movw R30,R24
	ldd R24,z+0
	subi R24,255    ; addi 1
	std z+0,R24
	.dbline 38
; 		}
L5:
	.dbline 48
; 	#elif defined(BUFF_DROPNEW)
; 		if (Buffer->Elements == BUFF_LENGTH)
; 		  return;
; 	
; 		  Buffer->Elements++;
; 	#elif defined(BUFF_NODROPCHECK)
; 		  Buffer->Elements++;
; 	#endif
; 	
; 		*(Buffer->InPtr) = Data;
	movw R30,R16
	ldd R26,z+32
	ldd R27,z+33
	st x,R18
	.dbline 49
; 		Buffer->InPtr++;
	movw R20,R30
	subi R20,224  ; offset = 32
	sbci R21,255
	movw R30,R20
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	std z+1,R25
	std z+0,R24
	.dbline 51
; 	
; 		if (Buffer->InPtr == &Buffer->Buffer[BUFF_LENGTH])
	movw R20,R16
	subi R20,224  ; offset = 32
	sbci R21,255
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	cp R2,R30
	cpc R3,R31
	brne L8
X2:
	.dbline 52
; 		  Buffer->InPtr = (RingBuff_Data_t*)&Buffer->Buffer;
	movw R30,R16
	std z+33,R17
	std z+32,R16
L8:
	.dbline 55
; 	
;     //Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R10
	.dbline -2
L3:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r temp_SREG 10 c
	.dbsym r Data 18 c
	.dbsym r Buffer 16 pS[.1]
	.dbend
	.dbfunc e Buffer_GetElement _Buffer_GetElement fc
;      temp_SREG -> R12
;       BuffData -> R10
;         Buffer -> R16,R17
	.even
_Buffer_GetElement::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 59
; }
; 
; RingBuff_Data_t Buffer_GetElement(RingBuff_t* Buffer)
; {
	.dbline 65
; 	RingBuff_Data_t BuffData;
; 	
; 	unsigned char temp_SREG;
;     
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R12,0x3f
	.dbline 66
;     CLI();//Disable global interrupts
	cli
	.dbline 75
;     
; #if defined(BUFF_EMPTYRETURNSZERO)
; 		if (!(Buffer->Elements))
; 		  return 0;
; #elif !defined(BUFF_NOEMPTYCHECK)
; 	#error No empty buffer check behaviour specified.
; #endif
; 
; 		BuffData = *(Buffer->OutPtr);
	movw R30,R16
	ldd R26,z+34
	ldd R27,z+35
	ld R10,x
	.dbline 77
; 	
; 		Buffer->OutPtr++;
	movw R24,R30
	adiw R24,34
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	std z+1,R25
	std z+0,R24
	.dbline 78
; 		Buffer->Elements--;
	movw R24,R16
	adiw R24,36
	movw R2,R24
	movw R30,R24
	ldd R24,z+0
	subi R24,1
	std z+0,R24
	.dbline 80
; 	
; 		if (Buffer->OutPtr == &Buffer->Buffer[BUFF_LENGTH])
	movw R24,R16
	adiw R24,32
	movw R30,R16
	ldd R2,z+34
	ldd R3,z+35
	cp R2,R24
	cpc R3,R25
	brne L11
X3:
	.dbline 81
; 		  Buffer->OutPtr = (RingBuff_Data_t*)&Buffer->Buffer;
	std z+35,R17
	std z+34,R16
L11:
	.dbline 84
; 	
;     //Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R12
	.dbline 86
; 	
; 	return BuffData;
	mov R16,R10
	.dbline -2
L10:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r temp_SREG 12 c
	.dbsym r BuffData 10 c
	.dbsym r Buffer 16 pS[.1]
	.dbend
	.dbfunc e Buffer_PeekElement _Buffer_PeekElement fc
;      temp_SREG -> R12
;       BuffData -> R10
;         Buffer -> R16,R17
	.even
_Buffer_PeekElement::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 91
; }
; 
; 
; RingBuff_Data_t Buffer_PeekElement(const RingBuff_t* Buffer)
; {
	.dbline 97
; 	RingBuff_Data_t BuffData;
; 
; 	unsigned char temp_SREG;
;     
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R12,0x3f
	.dbline 98
;     CLI();//Disable global interrupts
	cli
	.dbline 107
;     
; #if defined(BUFF_EMPTYRETURNSZERO)
; 		if (!(Buffer->Elements))
; 		  return 0;
; #elif !defined(BUFF_NOEMPTYCHECK)
; 	#error No empty buffer check behaviour specified.
; #endif
; 
; 		BuffData = *(Buffer->OutPtr);
	movw R30,R16
	adiw R30,34
	lpm R0,Z+
	lpm R1,Z
	movw R30,R0
	ldd R10,z+0
	.dbline 110
; 	
;     //Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R12
	.dbline 112
; 
; 	return BuffData;
	mov R16,R10
	.dbline -2
L13:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r temp_SREG 12 c
	.dbsym r BuffData 10 c
	.dbsym r Buffer 16 pkS[.1]
	.dbend
; }
