	.module LED8_Controller.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Controller.c
	.area lit(rom, con, rel)
_signon1::
	.byte 10,13,10,13,'L,'E,'D,56,32,'M,'o,'n,'i,'t,'o,'r
	.byte 32,'V,48,46,56,53,10,13,0
	.dbsym e signon1 _signon1 A[25:25]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Controller.c
	.dbfunc e IncrementNumStrg _IncrementNumStrg fI
;          index -> R16,R17
	.even
_IncrementNumStrg::
	.dbline -1
	.dbline 136
; /**************************************************************
; 
;    Program Title:  LED8 Controller
;    
;    Program Name:  LED8_Controller.c	  Version: 0.85
;    
;    Author:  SS	  					  Date:  October 10, 2006
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A
;    
;    The Led8 is a set of functions that configure Led AVR internal
;    peripherals for interrupt driven operation.  Custom applications can easily
;    be built on top to these basic functions.  Included is a complete data 
;    acquistion controller with user preferences loaded into EEPROM.  The Monitor
;    communicates with the user via an RS-232 port using the CDP.   The AVR is 
;    a smart powerful 8 bit RISC processor that can be easily programmed in C
;    with on chip TWI, SPI and analog and digital IO.  Functions are included 
;    to read/write data blocks to the on board Serial Flash.  On board sensors
;    (if included) include a dual axis 2G accelerometer, temperature and light
;    sensor and battery voltage monitor.
;    
;    Set Fuse bits as:  FEDFE2
;    
;    Key functions:
;    	   SPI Master with read/write function to serial flash
; 	   TWI 2-Wire Master Interrupt Controller
; 	   Real Time Clock setup with four configurable software timers
; 	   Full duplex interrupt drive USART with XON/XOFF flow control
; 	   1msec timer with four configurable software times
; 	   Analog controller setup
; 	   Digital port configuration
; 	   Accelerometer reader
; 	   Temperature reader
; 	   Light level reader
; 	   IntelHex32 download/upload for EEPROM, AVRFLASH and Serial Flash
; 	   Auto clock calibration
; 	   
;    Standard printf and scanf functions are not used in this version 
;    due to code size constraints.  The Wasp is available with an ATmega32
;    with twice the Flash and SRAM if printf and scanf functionality is 
;    important or a custom application requires more than the available
;    AVR Flash.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Led8_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash writer, XON/XOFF, 9,600baud
;  *    real time clock and auto-internal osc calibration.
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  * 
;  */ 
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <math.h>
; #include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; #include "TWI_slave.h"
; 
; 
; //  Variable declarations
; unsigned int intelsuperaddress,oldpage,oldbyteoffset,totalrxcnt;
; unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
; unsigned int mseccountdown1,mseccountdown2,mseccountdown3,flashcountdown;
; 
; unsigned int totalbytecnt,xoncnt,xoffcnt,decimalpoint;
; unsigned char frameerror,dataoverrun,numstrg[9];
; 
; extern int _textmode;
; 
; /* Static Variables */
; unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
; unsigned char UART_RxHead;
; unsigned char UART_RxTail;
; unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
; unsigned char UART_TxHead;
; unsigned char UART_TxTail;
; char  xoffsent, xonsent, enablexonoff, echoinchars,sendxoff;
; char  rxcnt,checkflag,rxcntmax;
; unsigned char  instrg[8],vlow,vhigh,blankindex,ledindex;
; 
; unsigned char FlashAddress[3];
; const char signon1[] = "\n\r\n\rLED8 Monitor V0.85\n\r";
; 
; // Function declarations
; unsigned char EEPROMwrite(int,unsigned char);
; unsigned char EEPROMread(int);
; int  ledchars[12];
; 
; 
; // *******************************************************
; //    Start of code
; // *******************************************************
; int  IncrementNumStrg(int index)
; {
	.dbline 137
;  	if(numstrg[index]==NUMBER0)  {
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R16
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,63
	brne L3
X0:
	.dbline 137
	.dbline 138
; 	    numstrg[index] = NUMBER1;
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R16
	add R30,R24
	adc R31,R25
	ldi R24,6
	std z+0,R24
	.dbline 139
; 		return 0;
	clr R16
	clr R17
	xjmp L2
L3:
	.dbline 141
; 		}
; 	return index;
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r index 16 I
	.dbend
	.dbfunc e Increment_Numstrg _Increment_Numstrg fV
	.even
_Increment_Numstrg::
	.dbline -1
	.dbline 145
; }
; 
; void Increment_Numstrg()
; {
	.dbline 146
; 	numstrg[7]++;
	lds R24,_numstrg+7
	subi R24,255    ; addi 1
	sts _numstrg+7,R24
	.dbline 147
; 	if(numstrg[7]>9)  {
	ldi R24,9
	lds R2,_numstrg+7
	cp R24,R2
	brlo X9
	xjmp L7
X9:
X1:
	.dbline 147
	.dbline 148
; 	    numstrg[7] = 0;
	clr R2
	sts _numstrg+7,R2
	.dbline 149
; 		numstrg[6]++;
	lds R24,_numstrg+6
	subi R24,255    ; addi 1
	sts _numstrg+6,R24
	.dbline 150
; 		if(numstrg[6]>9) {
	ldi R24,9
	lds R2,_numstrg+6
	cp R24,R2
	brlo X10
	xjmp L12
X10:
X2:
	.dbline 150
	.dbline 151
; 		    numstrg[6] = 0;
	clr R2
	sts _numstrg+6,R2
	.dbline 152
; 			numstrg[5]++;
	lds R24,_numstrg+5
	subi R24,255    ; addi 1
	sts _numstrg+5,R24
	.dbline 153
; 			if(numstrg[5]>9) {
	ldi R24,9
	lds R2,_numstrg+5
	cp R24,R2
	brlo X11
	xjmp L17
X11:
X3:
	.dbline 153
	.dbline 154
; 			    numstrg[5] = 0;
	clr R2
	sts _numstrg+5,R2
	.dbline 155
; 			    numstrg[4]++;
	lds R24,_numstrg+4
	subi R24,255    ; addi 1
	sts _numstrg+4,R24
	.dbline 156
; 				if(numstrg[4]>9) {
	ldi R24,9
	lds R2,_numstrg+4
	cp R24,R2
	brsh L22
X4:
	.dbline 156
	.dbline 157
; 				    numstrg[4] = 0;
	clr R2
	sts _numstrg+4,R2
	.dbline 158
; 			        numstrg[3]++;
	lds R24,_numstrg+3
	subi R24,255    ; addi 1
	sts _numstrg+3,R24
	.dbline 159
; 					if(numstrg[3]>9) {
	ldi R24,9
	lds R2,_numstrg+3
	cp R24,R2
	brsh L27
X5:
	.dbline 159
	.dbline 160
; 			            numstrg[3] = 0;
	clr R2
	sts _numstrg+3,R2
	.dbline 161
; 			            numstrg[2]++;
	lds R24,_numstrg+2
	subi R24,255    ; addi 1
	sts _numstrg+2,R24
	.dbline 162
; 						if(numstrg[2]>9) {
	ldi R24,9
	lds R2,_numstrg+2
	cp R24,R2
	brsh L32
X6:
	.dbline 162
	.dbline 163
; 			                numstrg[2] = 0;
	clr R2
	sts _numstrg+2,R2
	.dbline 164
; 			                numstrg[1]++;
	lds R24,_numstrg+1
	subi R24,255    ; addi 1
	sts _numstrg+1,R24
	.dbline 165
; 						    if(numstrg[1]>9) {
	ldi R24,9
	lds R2,_numstrg+1
	cp R24,R2
	brsh L37
X7:
	.dbline 165
	.dbline 166
; 			                    numstrg[1] = 0;
	clr R2
	sts _numstrg+1,R2
	.dbline 167
; 			                    numstrg[0]++;
	lds R24,_numstrg
	subi R24,255    ; addi 1
	sts _numstrg,R24
	.dbline 168
; 							    if(numstrg[0]>9)  numstrg[0] = 0;
	ldi R24,9
	lds R2,_numstrg
	cp R24,R2
	brsh L41
X8:
	.dbline 168
	clr R2
	sts _numstrg,R2
L41:
	.dbline 169
; 								}
L37:
	.dbline 170
; 							}
L32:
	.dbline 171
; 						}
L27:
	.dbline 172
; 					}
L22:
	.dbline 173
; 				}
L17:
	.dbline 174
; 			}
L12:
	.dbline 175
; 		}
L7:
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Display_Int_Number _Display_Int_Number fV
;        outstrg -> y+2
;              i -> R20,R21
;         ivalue -> R10,R11
	.even
_Display_Int_Number::
	xcall push_xgset300C
	movw R10,R16
	sbiw R28,14
	.dbline -1
	.dbline 180
; }
; 
; // Convert a integer number to string and display
; void Display_Int_Number(int ivalue)
; {
	.dbline 184
;     unsigned char outstrg[12];
; 	int i;
; 	
; 	decimalpoint = 8;
	ldi R24,8
	ldi R25,0
	sts _decimalpoint+1,R25
	sts _decimalpoint,R24
	.dbline 186
; //	sprintf(outstrg,"%#8d",ivalue);
; 	itoa(outstrg,ivalue,10);
	ldi R24,10
	std y+1,R25
	std y+0,R24
	movw R18,R10
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _itoa
	.dbline 187
; 	for(i=0; i<strlen(outstrg); i++) {
	clr R20
	clr R21
	xjmp L47
L44:
	.dbline 187
	.dbline 188
; 		if(outstrg[i]==' ') numstrg[i] = 10; 
	movw R24,R28
	adiw R24,2
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,32
	brne L48
X12:
	.dbline 188
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldi R24,10
	std z+0,R24
	xjmp L49
L48:
	.dbline 189
; 		else numstrg[i] = outstrg[i]-'0';
	movw R24,R28
	adiw R24,2
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	subi R24,48
	ldi R30,<_numstrg
	ldi R31,>_numstrg
	movw R26,R20
	add R26,R30
	adc R27,R31
	st x,R24
L49:
	.dbline 190
; 		} 
L45:
	.dbline 187
	subi R20,255  ; offset = 1
	sbci R21,255
L47:
	.dbline 187
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strlen
	cp R20,R16
	cpc R21,R17
	brsh X14
	xjmp L44
X14:
X13:
	.dbline -2
L43:
	.dbline 0 ; func end
	adiw R28,14
	xjmp pop_xgset300C
	.dbsym l outstrg 2 A[12:12]c
	.dbsym r i 20 I
	.dbsym r ivalue 10 I
	.dbend
	.dbfunc e Display_Float_Number _Display_Float_Number fV
;         status -> y+2
;        skipcnt -> R22,R23
;  decimaloffset -> R12,R13
;        outstrg -> R10,R11
;              i -> R20,R21
; decimallocation -> R14,R15
;         fvalue -> y+14
	.even
_Display_Float_Number::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,4
	ldd R14,y+18
	ldd R15,y+19
	.dbline -1
	.dbline 204
; }
; 
; 	//if(decimalpoint == 7) sprintf(outstrg,"%#9.7f",fvalue);
; 	//else if(decimalpoint == 6) sprintf(outstrg,"%#9.6f",fvalue);
; 	//else if(decimalpoint == 5) sprintf(outstrg,"%#9.5f",fvalue);
; 	//else if(decimalpoint == 4) sprintf(outstrg,"%#9.4f",fvalue);
; 	//else if(decimalpoint == 3) sprintf(outstrg,"%#9.3f",fvalue);
; 	//else if(decimalpoint == 2) sprintf(outstrg,"%#9.2f",fvalue);
; 	//else if(decimalpoint == 1) sprintf(outstrg,"%#9.1f",fvalue);
; 
; // Convert a floating point number to string and display
; //    Set decimal point where you want
; void Display_Float_Number(float fvalue,int decimallocation)
; {
	.dbline 208
; 	char *outstrg;
; 	int skipcnt,i,status,decimaloffset;
; 	
; 	skipcnt = 0;
	clr R22
	clr R23
	.dbline 209
; 	outstrg = ftoa(fvalue,&status);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	xcall _ftoa
	movw R10,R16
	.dbline 211
; 	// Find decimal point location
; 	for(i=0; i<8; i++)  numstrg[i] = 0;
	clr R20
	clr R21
L51:
	.dbline 211
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R20
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
L52:
	.dbline 211
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 211
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L51
X15:
	.dbline 212
; 	decimalpoint = decimallocation;
	sts _decimalpoint+1,R15
	sts _decimalpoint,R14
	.dbline 213
; 	for(i=0; i<strlen(outstrg)-1; i++) {
	clr R20
	clr R21
	xjmp L58
L55:
	.dbline 213
	.dbline 214
; 		if(outstrg[i]=='.') {
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,46
	brne L59
X16:
	.dbline 214
	.dbline 215
; 		    skipcnt = 1;
	ldi R22,1
	ldi R23,0
	.dbline 216
; 			decimaloffset = decimallocation - (8-i);
	ldi R24,8
	ldi R25,0
	sub R24,R20
	sbc R25,R21
	movw R12,R14
	sub R12,R24
	sbc R13,R25
	.dbline 217
; 			}
L59:
	.dbline 218
; 		if(outstrg[i]==' ') numstrg[i] = 10; 
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,32
	brne L61
X17:
	.dbline 218
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldi R24,10
	std z+0,R24
	xjmp L62
L61:
	.dbline 219
; 		else numstrg[i+decimaloffset] = outstrg[i+skipcnt+decimaloffset]-'0';
	movw R30,R20
	add R30,R22
	adc R31,R23
	add R30,R12
	adc R31,R13
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	subi R24,48
	movw R30,R20
	add R30,R12
	adc R31,R13
	ldi R26,<_numstrg
	ldi R27,>_numstrg
	add R30,R26
	adc R31,R27
	std z+0,R24
L62:
	.dbline 220
; 		} 
L56:
	.dbline 213
	subi R20,255  ; offset = 1
	sbci R21,255
L58:
	.dbline 213
	movw R16,R10
	xcall _strlen
	movw R24,R16
	sbiw R24,1
	cp R20,R24
	cpc R21,R25
	brsh X19
	xjmp L55
X19:
X18:
	.dbline -2
L50:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l status 2 I
	.dbsym r skipcnt 22 I
	.dbsym r decimaloffset 12 I
	.dbsym r outstrg 10 pc
	.dbsym r i 20 I
	.dbsym r decimallocation 14 I
	.dbsym l fvalue 14 D
	.dbend
	.dbfunc e Init_LED8 _Init_LED8 fV
	.even
_Init_LED8::
	.dbline -1
	.dbline 225
; }
; 
; // Initialize LED8 to default starting state
; void Init_LED8()
; {
	.dbline 226
;     ledchars[0] = NUMBER0;
	ldi R24,63
	ldi R25,0
	sts _ledchars+1,R25
	sts _ledchars,R24
	.dbline 227
; 	ledchars[1] = NUMBER1;
	ldi R24,6
	sts _ledchars+2+1,R25
	sts _ledchars+2,R24
	.dbline 228
;     ledchars[2] = NUMBER2;
	ldi R24,91
	sts _ledchars+4+1,R25
	sts _ledchars+4,R24
	.dbline 229
; 	ledchars[3] = NUMBER3;
	ldi R24,79
	sts _ledchars+6+1,R25
	sts _ledchars+6,R24
	.dbline 230
;     ledchars[4] = NUMBER4;
	ldi R24,102
	sts _ledchars+8+1,R25
	sts _ledchars+8,R24
	.dbline 231
; 	ledchars[5] = NUMBER5;
	ldi R24,109
	sts _ledchars+10+1,R25
	sts _ledchars+10,R24
	.dbline 232
;     ledchars[6] = NUMBER6;
	ldi R24,124
	sts _ledchars+12+1,R25
	sts _ledchars+12,R24
	.dbline 233
; 	ledchars[7] = NUMBER7;
	ldi R24,7
	sts _ledchars+14+1,R25
	sts _ledchars+14,R24
	.dbline 234
;     ledchars[8] = NUMBER8;
	ldi R24,127
	sts _ledchars+16+1,R25
	sts _ledchars+16,R24
	.dbline 235
; 	ledchars[9] = NUMBER9;
	ldi R24,103
	sts _ledchars+18+1,R25
	sts _ledchars+18,R24
	.dbline 236
; 	ledchars[10]= NUMBER10;
	clr R2
	clr R3
	sts _ledchars+20+1,R3
	sts _ledchars+20,R2
	.dbline -2
L63:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Act_On_Failure_In_Last_Transmission _TWI_Act_On_Failure_In_Last_Transmission fc
;    TWIerrorMsg -> R10
	.even
_TWI_Act_On_Failure_In_Last_Transmission::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 240
; }
; 
; unsigned char TWI_Act_On_Failure_In_Last_Transmission(unsigned char TWIerrorMsg)
; {
	.dbline 248
;     // A failure has occurred, use TWIerrorMsg to determine the nature of 
; 	// the failure and take appropriate actions.
;     // See header file for a list of possible failures messages.
;   
;     // This very simple example puts the error code on PORTB and restarts 
; 	// the transceiver with all the same data in the transmission buffers.
;     //PORTB = TWIerrorMsg;
;     TWI_Start_Transceiver();
	xcall _TWI_Start_Transceiver
	.dbline 250
;                     
;     return TWIerrorMsg; 
	mov R16,R10
	.dbline -2
L74:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r TWIerrorMsg 10 c
	.dbend
	.dbfunc e Check_TWI _Check_TWI fc
	.even
_Check_TWI::
	st -y,R10
	.dbline -1
	.dbline 264
; }
; 
; unsigned char messageBuf[TWI_BUFFER_SIZE],TWI_slaveAddress,temp;
; 
; // See if any commands came in
; //   The TWI handler places received data in circular buffer so the 
; //   main program loop can pick the date up when its ready.  Note 
; //   that the ISR is able to respond to data retreival requests
; //   immediately as they come in.
; 
; // This needs to be redone for multi byte operation
; // and to not wait
; unsigned char  Check_TWI()
; {
	.dbline 266
;     // Check if the TWI Transceiver has completed an operation.
;     if(!TWI_Transceiver_Busy())   {
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L76
X20:
	.dbline 266
	.dbline 268
;     	// Check if the last operation was successful
;       	if(TWI_statusReg.status.lastTransOK)   {
	lds R24,_TWI_statusReg
	andi R24,1
	breq L78
X21:
	.dbline 268
	.dbline 270
;     	    // Check if the last operation was a reception
;         	if(TWI_statusReg.status.RxDataInBuf)   {
	lds R24,_TWI_statusReg
	lsr R24
	andi R24,1
	breq L80
X22:
	.dbline 270
	.dbline 271
;           		TWI_Get_Data_From_Transceiver(messageBuf, 2);         
	ldi R18,2
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 274
;     			// Check if the last operation was a reception 
; 				// as General Call        
;           		if(TWI_statusReg.status.genAddressCall) {
	lds R24,_TWI_statusReg
	lsr R24
	lsr R24
	andi R24,1
	breq L82
X23:
	.dbline 274
	.dbline 276
;           		    // Do operation here                                   
;           			}
	xjmp L83
L82:
	.dbline 279
;     			// Ends up here if the last operation was a 
; 				// reception as Slave Address Match                  
;           		else  {
	.dbline 282
;     				// Example of how to interpret a command and respond.
;           			// TWI_CMD_MASTER_WRITE stores the data to PORTB
;             		if(messageBuf[0]==TWI_CMD_MASTER_WRITE)  ;
	lds R24,_messageBuf
	cpi R24,16
	brne L84
X24:
	.dbline 282
L84:
	.dbline 286
;                         
;             		// TWI_CMD_MASTER_READ prepares the data from PINB 
; 					// in the transceiver buffer for the TWI master to fetch.
;             		if(messageBuf[0]==TWI_CMD_MASTER_READ) {
	lds R24,_messageBuf
	cpi R24,32
	brne L86
X25:
	.dbline 286
	.dbline 287
;               			messageBuf[0] = PINB;                             
	in R2,0x3
	sts _messageBuf,R2
	.dbline 288
;               			TWI_Start_Transceiver_With_Data(messageBuf,1);           
	ldi R18,1
	ldi R16,<_messageBuf
	ldi R17,>_messageBuf
	xcall _TWI_Start_Transceiver_With_Data
	.dbline 289
;             			}
L86:
	.dbline 290
;           			}
L83:
	.dbline 291
;         		}
L80:
	.dbline 295
; 
;     	    // Check if the TWI Transceiver has already been started.
;     	    // If not then restart it to prepare it for new receptions.             
;             if(!TWI_Transceiver_Busy())   {
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L79
X26:
	.dbline 295
	.dbline 296
;                 TWI_Start_Transceiver();
	xcall _TWI_Start_Transceiver
	.dbline 297
;                 }      
	.dbline 298
;             }
	xjmp L79
L78:
	.dbline 300
;         // Ends up here if the last operation completed unsuccessfully
;         else {
	.dbline 301
;            TWI_Act_On_Failure_In_Last_Transmission(TWI_Get_State_Info());
	xcall _TWI_Get_State_Info
	mov R10,R16
	xcall _TWI_Act_On_Failure_In_Last_Transmission
	.dbline 302
;            }
L79:
	.dbline 303
;        }
L76:
	.dbline 304
; 	return 'p';
	ldi R16,112
	.dbline -2
L75:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbend
	.dbfunc e main _main fV
;         yvalue -> y+19
;          numbr -> <dead>
;   countervalue -> <dead>
; blackfinresetmode -> <dead>
;           icnt -> <dead>
; firstmeasurement -> <dead>
;        slaverx -> <dead>
;        inbytes -> y+14
;     twistatus4 -> <dead>
;     twistatus3 -> <dead>
;     twistatus2 -> <dead>
;     twistatus1 -> <dead>
;         inbyte -> <dead>
;         inchar -> <dead>
;      loopcount -> y+10
; dataoutputperiod -> R20,R21
;         toggle -> R10
;         ivalue -> R22,R23
;    loopsetting -> R20,R21
;         xvalue -> y+6
;       loopmode -> R22,R23
;       delaynum -> y+2
;              i -> R20,R21
;              j -> R22,R23
	.even
_main::
	sbiw R28,27
	.dbline -1
	.dbline 311
; }
; 
; //*************************************************************
; //  Main work starts here
; //*************************************************************
; void main()
; {
	.dbline 320
; 	unsigned char inchar,inbyte,twistatus1,twistatus2,twistatus3,twistatus4;
; 	unsigned char inbytes[5],toggle,slaverx,firstmeasurement;
; 	int i,icnt,j,loopsetting,loopmode,blackfinresetmode,countervalue,numbr;
; 	int dataoutputperiod,ivalue;
; 	long loopcount,delaynum;
; 	float xvalue,yvalue;
; 
; 
; 	Init_AVR();
	xcall _Init_AVR
	.dbline 321
; 	Init_LED8();
	xcall _Init_LED8
	.dbline 323
; 
; 	loopsetting = 500;   // 1 second delay
	ldi R20,500
	ldi R21,1
	.dbline 324
; 	loopmode = 0;  toggle = 0;
	clr R22
	clr R23
	.dbline 324
	clr R10
	.dbline 325
; 	mseccountdown1 = loopsetting;
	sts _mseccountdown1+1,R21
	sts _mseccountdown1,R20
	.dbline 326
; 	loopcount = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+10,R24
	std y+11,R25
	std y+12,R26
	std y+13,R27
	.dbline 327
; 	dataoutputperiod = 10;  // seconds
	.dbline 328
; 	blankindex = 0;
	clr R2
	sts _blankindex,R2
	.dbline 336
; 	
; //	WriteEEPROM(0,"SOC Robotics V0.85");
; 
; 	//Set_LED_Segments(0x55);
; 	//Decimal_Point(OFF);
; 	//PORTB |= 0x01;
; 	
;     for(i=0; i<7; i++)  numstrg[i] = 10;
	clr R20
L91:
	.dbline 336
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldi R24,10
	std z+0,R24
L92:
	.dbline 336
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 336
	st -y,R30
	cpi R20,7
	ldi R30,0
	cpc R21,R30
	ld R30,y+
	brlt L91
X27:
	.dbline 337
; 	numstrg[7] = 0;
	clr R2
	sts _numstrg+7,R2
	.dbline 338
; 	numstrg[8] = 0;
	sts _numstrg+8,R2
	.dbline 340
; 	
; 	delaynum = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
	.dbline 341
; 	decimalpoint = 5;
	ldi R24,5
	ldi R25,0
	sts _decimalpoint+1,R25
	sts _decimalpoint,R24
	.dbline 342
; 	xvalue = 12.24500;
	ldi R16,<L97
	ldi R17,>L97
	xcall lpm32
	std y+6,R16
	std y+7,R17
	std y+8,R18
	std y+9,R19
	.dbline 343
; 	ivalue = 100;
	ldi R22,100
	ldi R23,0
	.dbline 344
; 	i = 0; 
	clr R20
	clr R21
	.dbline 347
; 
;     // Own TWI slave address
;     TWI_slaveAddress = 0x10;
	ldi R24,16
	sts _TWI_slaveAddress,R24
	.dbline 351
; 	
;     // Initialise TWI module for slave operation. 
;     // Include address and/or enable General Call.
;     TWI_Slave_Initialise((TWI_slaveAddress<<TWI_ADR_BITS)|(TRUE<<TWI_GEN_BIT));                                 //
	mov R16,R24
	lsl R16
	ori R16,1
	xcall _TWI_Slave_Initialise
	.dbline 355
;   
;     // Start the TWI transceiver to enable reception of the 
; 	// first command from the TWI Master.
;     TWI_Start_Transceiver();
	xcall _TWI_Start_Transceiver
	.dbline 357
; 
; 	_SEI(); // Enable interrupts => enable UART interrupts
	sei
	xjmp L99
L98:
	.dbline 359
; 
; 	while(1) {
	.dbline 360
; 	    for(i=0; i<10; i++)  {
	clr R20
	clr R21
L101:
	.dbline 360
	.dbline 361
;             for(j=0; j<8; j++)  numstrg[j] = i;
	clr R22
	clr R23
L105:
	.dbline 361
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	movw R30,R22
	add R30,R24
	adc R31,R25
	std z+0,R20
L106:
	.dbline 361
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 361
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	brlt L105
X28:
	.dbline 362
; 	        decimalpoint = i;
	sts _decimalpoint+1,R21
	sts _decimalpoint,R20
	.dbline 363
; 			if(decimalpoint>8) decimalpoint = 8;
	ldi R24,8
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brsh L109
X29:
	.dbline 363
	sts _decimalpoint+1,R25
	sts _decimalpoint,R24
L109:
	.dbline 364
; 		    Delaymsec(150);
	ldi R16,150
	ldi R17,0
	xcall _Delaymsec
	.dbline 365
; 		    }
L102:
	.dbline 360
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 360
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	brlt L101
X30:
	.dbline 366
; 		}
L99:
	.dbline 359
	xjmp L98
L111:
	.dbline 369
; 	
; 	// Real work starts here 	
; 	while (1) {
	.dbline 372
; 	
; 		    // See if anything came in TWI
; 			Check_TWI();
	xcall _Check_TWI
	.dbline 375
; 			
; 			// Display some sample values
; 			if(delaynum++>50000) {
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	std y+23,R2
	std y+24,R3
	std y+25,R4
	std y+26,R5
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+23
	ldd R3,y+24
	ldd R4,y+25
	ldd R5,y+26
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldi R24,80
	ldi R25,195
	ldi R26,0
	ldi R27,0
	ldd R2,y+23
	ldd R3,y+24
	ldd R4,y+25
	ldd R5,y+26
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brge L114
X31:
	.dbline 375
	.dbline 378
; 			    //Increment_Numstrg();
; 				//for(i=0; i<10; i++)  numstrg[i] = 10;
; 				xvalue += .00025;
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	ldi R16,<L116
	ldi R17,>L116
	xcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	xcall fpadd2
	std y+6,R16
	std y+7,R17
	std y+8,R18
	std y+9,R19
	.dbline 380
; 				//xvalue += 1;
; 				ivalue += 1;
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 386
; 				
; 				//for(j=0; j<8; j++) numstrg[j] = 10;
; 				//numstrg[i++] = '1'-'0';
; 				//if(i>8) i = 0;
; 				
; 				Display_Float_Number(xvalue,5);
	ldi R24,5
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	xcall _Display_Float_Number
	.dbline 388
; 				//Display_Int_Number(ivalue);
; 				delaynum = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
	.dbline 389
; 				}
L114:
	.dbline 396
; 			//Update_NumStrg();
; 			//ShortDelay(delaynum);
; 			//delaynum += 10;
; 			//if(delaynum>5000) delaynum = 1;
; 	
; 		// Blink green led slowly to show AVR is alive
; 		if(mseccountdown1==0) {
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne L117
	tst R3
	brne L117
X32:
	.dbline 396
	.dbline 398
; 			//Set_LED_Segments(0x55);
; 			mseccountdown1 = loopsetting;
	sts _mseccountdown1+1,R21
	sts _mseccountdown1,R20
	.dbline 399
; 			if(loopmode)  {
	cpi R22,0
	cpc R22,R23
	breq L119
X33:
	.dbline 399
	.dbline 401
; 			    //LED_Power(LED3,ON);
; 				loopmode = 0;
	clr R22
	clr R23
	.dbline 402
; 				}
	xjmp L120
L119:
	.dbline 403
; 			else {
	.dbline 405
; 			    //LED_Power(LED3,OFF);
; 				loopmode = 1;
	ldi R22,1
	ldi R23,0
	.dbline 406
; 				}
L120:
	.dbline 407
; 			}
L117:
	.dbline 408
; 		}
L112:
	.dbline 369
	xjmp L111
X34:
	.dbline -2
L90:
	.dbline 0 ; func end
	adiw R28,27
	ret
	.dbsym l yvalue 19 D
	.dbsym l numbr 3 I
	.dbsym l countervalue 3 I
	.dbsym l blackfinresetmode 3 I
	.dbsym l icnt 3 I
	.dbsym l firstmeasurement 3 c
	.dbsym l slaverx 3 c
	.dbsym l inbytes 14 A[5:5]c
	.dbsym l twistatus4 3 c
	.dbsym l twistatus3 3 c
	.dbsym l twistatus2 3 c
	.dbsym l twistatus1 3 c
	.dbsym l inbyte 3 c
	.dbsym l inchar 3 c
	.dbsym l loopcount 10 L
	.dbsym r dataoutputperiod 20 I
	.dbsym r toggle 10 c
	.dbsym r ivalue 22 I
	.dbsym r loopsetting 20 I
	.dbsym l xvalue 6 D
	.dbsym r loopmode 22 I
	.dbsym l delaynum 2 L
	.dbsym r i 20 I
	.dbsym r j 22 I
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Controller.c
_temp::
	.blkb 1
	.dbsym e temp _temp c
_TWI_slaveAddress::
	.blkb 1
	.dbsym e TWI_slaveAddress _TWI_slaveAddress c
_messageBuf::
	.blkb 4
	.dbsym e messageBuf _messageBuf A[4:4]c
_blankindex::
	.blkb 1
	.dbsym e blankindex _blankindex c
_totalrxcnt::
	.blkb 2
	.dbsym e totalrxcnt _totalrxcnt i
_oldbyteoffset::
	.blkb 2
	.dbsym e oldbyteoffset _oldbyteoffset i
_oldpage::
	.blkb 2
	.dbsym e oldpage _oldpage i
_intelsuperaddress::
	.blkb 2
	.dbsym e intelsuperaddress _intelsuperaddress i
_FlashAddress::
	.blkb 3
	.dbsym e FlashAddress _FlashAddress A[3:3]c
_vhigh::
	.blkb 1
	.dbsym e vhigh _vhigh c
_vlow::
	.blkb 1
	.dbsym e vlow _vlow c
_instrg::
	.blkb 8
	.dbsym e instrg _instrg A[8:8]c
_rxcntmax::
	.blkb 1
	.dbsym e rxcntmax _rxcntmax c
_checkflag::
	.blkb 1
	.dbsym e checkflag _checkflag c
_rxcnt::
	.blkb 1
	.dbsym e rxcnt _rxcnt c
_sendxoff::
	.blkb 1
	.dbsym e sendxoff _sendxoff c
_echoinchars::
	.blkb 1
	.dbsym e echoinchars _echoinchars c
_enablexonoff::
	.blkb 1
	.dbsym e enablexonoff _enablexonoff c
_xonsent::
	.blkb 1
	.dbsym e xonsent _xonsent c
_xoffsent::
	.blkb 1
	.dbsym e xoffsent _xoffsent c
_UART_TxTail::
	.blkb 1
	.dbsym e UART_TxTail _UART_TxTail c
_UART_TxHead::
	.blkb 1
	.dbsym e UART_TxHead _UART_TxHead c
_UART_TxBuf::
	.blkb 64
	.dbsym e UART_TxBuf _UART_TxBuf A[64:64]c
_UART_RxTail::
	.blkb 1
	.dbsym e UART_RxTail _UART_RxTail c
_UART_RxHead::
	.blkb 1
	.dbsym e UART_RxHead _UART_RxHead c
_UART_RxBuf::
	.blkb 64
	.dbsym e UART_RxBuf _UART_RxBuf A[64:64]c
_ledchars::
	.blkb 24
	.dbsym e ledchars _ledchars A[24:12]I
_numstrg::
	.blkb 9
	.dbsym e numstrg _numstrg A[9:9]c
_ledindex::
	.blkb 1
	.dbsym e ledindex _ledindex c
_dataoverrun::
	.blkb 1
	.dbsym e dataoverrun _dataoverrun c
_frameerror::
	.blkb 1
	.dbsym e frameerror _frameerror c
_decimalpoint::
	.blkb 2
	.dbsym e decimalpoint _decimalpoint i
_xoffcnt::
	.blkb 2
	.dbsym e xoffcnt _xoffcnt i
_xoncnt::
	.blkb 2
	.dbsym e xoncnt _xoncnt i
_totalbytecnt::
	.blkb 2
	.dbsym e totalbytecnt _totalbytecnt i
_flashcountdown::
	.blkb 2
	.dbsym e flashcountdown _flashcountdown i
_mseccountdown3::
	.blkb 2
	.dbsym e mseccountdown3 _mseccountdown3 i
_mseccountdown2::
	.blkb 2
	.dbsym e mseccountdown2 _mseccountdown2 i
_mseccountdown1::
	.blkb 2
	.dbsym e mseccountdown1 _mseccountdown1 i
_rtccountdown4::
	.blkb 2
	.dbsym e rtccountdown4 _rtccountdown4 i
_rtccountdown3::
	.blkb 2
	.dbsym e rtccountdown3 _rtccountdown3 i
_rtccountdown2::
	.blkb 2
	.dbsym e rtccountdown2 _rtccountdown2 i
_rtccountdown1::
	.blkb 2
	.dbsym e rtccountdown1 _rtccountdown1 i
	.area lit(rom, con, rel)
L116:
	.word 0x126f,0x3983
L97:
	.word 0xeb85,0x4143
; }
; 
; /*  
;   // A simplified example.
;   // This will store data received on PORTB, and increment it before sending it back.
; 
;   TWI_Start_Transceiver( );    
;          
;   for(;;)
;   {
;     if ( ! TWI_Transceiver_Busy() )                              
;     {
;       if ( TWI_statusReg.RxDataInBuf )
;       {
;         TWI_Get_Data_From_Transceiver(&temp, 1);  
;         PORTB = temp;
;       }
;       temp = PORTB + 1;
;       TWI_Start_Transceiver_With_Data(&temp, 1); 
;     }
;     __no_operation();   // Do something else while waiting
;   }
; }
; 
; */
