	.module LED8_SPI.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_SPI.c
	.dbfunc e Release_SPI _Release_SPI fV
	.even
_Release_SPI::
	.dbline -1
	.dbline 70
; /**************************************************************
; 
;    Program Title:  Led8 Controller
;    
;    Program Name:  LED8_SPI.c	Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement an SPI Master controller
;    for the Wasp.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom48v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; 
; //  Free SPI pins
; void Release_SPI(void)
; {
	.dbline 72
; 	// Disable SPI, Master 
; 	SPCR = 0x00;
	clr R2
	out 0x2c,R2
	.dbline 78
; 
;  	// Set MOSI and SCK input, all others input
; //	DDRB = 0x00;
; 	
; 	// Change Atmel Flash CS to input (PF2 - Port C bit 4)
; 	DDRC &= 0xEF;
	in R24,0x7
	andi R24,239
	out 0x7,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SPI_MasterTransmit _SPI_MasterTransmit fV
;            cnt -> y+0
;          cData -> R16
	.even
_SPI_MasterTransmit::
	sbiw R28,4
	.dbline -1
	.dbline 83
; }
; 
; // TODO - break if no reception
; void SPI_MasterTransmit(unsigned char cData)
; {
	.dbline 86
;     long cnt;
; 	
; 	cnt = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	.dbline 88
;     // Start transmisstion
; 	SPDR = cData;
	out 0x2e,R16
L3:
	.dbline 91
; 	// Wait for transmission to complete
; //	puts("wait for spi tx to complete\n\r");
; 	while(!(SPSR & 0x80)) ;
L4:
	.dbline 91
	in R2,0x2d
	sbrs R2,7
	rjmp L3
X0:
	.dbline -2
L2:
	.dbline 0 ; func end
	adiw R28,4
	ret
	.dbsym l cnt 0 L
	.dbsym r cData 16 c
	.dbend
	.dbfunc e SPI_MasterReceive _SPI_MasterReceive fc
	.even
_SPI_MasterReceive::
	.dbline -1
	.dbline 96
; }
; 
; // TODO - break if no reception
; unsigned char SPI_MasterReceive(void)
; {
	.dbline 98
;     // Wait for reception to complete
; 	SPDR = 0x00;
	clr R2
	out 0x2e,R2
L7:
	.dbline 99
; 	while(!(SPSR & 0x80)) ;
L8:
	.dbline 99
	in R2,0x2d
	sbrs R2,7
	rjmp L7
X1:
	.dbline 101
; 	
; 	return SPDR;
	in R16,0x2e
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
; }
